//oop_ex112.java
//Interfaces

import java.io.*;



//interfaces
interface printable
{
	public static final int p = 0;	
	public abstract void print( );	
	public abstract void printToFile(String filename);	
}

interface scaleable
{
	//public int S = 0;					//can't have non-final attribute
	public final int s = 0;					
	//public void Scale(int f){ }		//can't have non-abstract method
	public abstract void scale(int f);	
}



//abstract base class
abstract class shape
{
	public abstract void move(int x, int y);	//abstract method
	abstract void draw();						//abstract method
}



//concrete derived classes
class circle extends shape implements printable, scaleable
{
	public void move(int x, int y){ System.out.println("do move circle by ("+x+", "+y+")"); }
	void draw(){ System.out.println("do draw circle"); }

	public void print( ){System.out.println("do print circle");}	
	public void printToFile(String filename){System.out.println("do print circle on "+filename);}	

	public void scale(int f){ System.out.println("do scale circle by "+f); }		
}


class triangle extends shape implements printable, scaleable
{
	public void move(int x, int y){ System.out.println("do move triangle by ("+x+", "+y+")"); }
	void draw(){ System.out.println("do draw triangle"); }

	public void print( ){System.out.println("do print triangle");}	
	public void printToFile(String filename){System.out.println("do print triangle on "+filename);}	

	public void scale(int f){ System.out.println("do scale triangle by "+f); }		
}


class square extends triangle implements printable, scaleable
{
	public void move(int x, int y){ System.out.println("do move square by ("+x+", "+y+")"); }
	void draw(){ System.out.println("do draw square"); }

	public void print( ){System.out.println("do print square");}	
	public void printToFile(String filename){System.out.println("do print square on "+filename);}	

	public void scale(int f){ System.out.println("do scale square by "+f); }		
}


class test
{
	public static void main(String[] args)
	{
		circle ci = new circle();
		triangle tr = new triangle();
		square sq = new square();

		shape [] shapeArr = { ci, tr, sq};	//manage and manipulate using references of abstract class

		for(int i=0; i<shapeArr.length; i++)
			shapeArr[i].draw();

		for(int i=0; i<shapeArr.length; i++)
			shapeArr[i].move(i,i);

		//for(int i=0; i<shapeArr.length; i++)		//not allowed. Why?
		//	shapeArr[i].printToFile("out.txt");

		//for(int i=0; i<shapeArr.length; i++)		//not allowed. Why?
		//	shapeArr[i].scale(i+1);

		printable [] pArr = { ci, tr, sq};	//manage and manipulate using references of interface
	
		for(int i=0; i<shapeArr.length; i++)
			pArr[i].print();

		for(int i=0; i<shapeArr.length; i++)
			pArr[i].printToFile("out.txt");
		
		scaleable [] sArr = { ci, tr, sq};	//manage and manipulate using references of interface

		for(int i=0; i<shapeArr.length; i++)
			sArr[i].scale(i+1);

	}
}