//oop_ex112n.java
//Interfaces

import java.io.*;



//interfaces
interface Work
{
	public abstract void setDept(String d);
	public abstract String getDept();
}

interface Study
{
	public abstract void setStdDept(String d);
	public abstract String getStdDept();
}


//abstract base class
class Person
{
	public String name;

	public	Person(String n)
	{
		name = n;
	}

	public void print()
	{
		System.out.println("Person name = " + name);
	}
}


//concrete derived classes
class Staff extends Person implements Work
{
	private	String dept;
	public double salary;

	public Staff(String n, String d, double s)
	{
		super(n);
		dept = d;
		salary = s;
	}

	public void setDept(String d){ dept = d; }
	public String getDept(){ return dept; }
	
	public void print()
	{
		System.out.println("Staff name = " + name);
		System.out.println(",who works in " + dept);
		System.out.println(",whose salary is " + salary);
		System.out.println();
	}
}


class Student extends Person implements Study
{
	private	String dept;
	public	String level;


	public Student(String n, String d, String l)
	{
		super(n);
		dept = d;
		level = l;
	}

	public void setStdDept(String d){ dept = d; }
	public String getStdDept(){ return dept; }
	
	public void print()
	{
		System.out.println("Student name = " + name);
		System.out.println(",who studies in " + dept);
		System.out.println(",whose level is " + level);
		System.out.println();
	}
}

	
class TA extends Student implements Work
{
	private	String course;

	private	String dept;
	public double salary;

	public	TA( String n, String wd, double s, String sd, String l, String c)
	{
		super(n, sd, l);
		dept = wd;
		salary = s;
		course = c;
	}

	public void setDept(String d){ dept = d; }
	public String getDept(){ return dept; }

	public void setCourse(String c){ course = c; }
	public String getCourse(){ return course; }
	
	public void print()
	{
		System.out.println("TA name = " + name);
		
		System.out.println(",who studies in " + getStdDept());
		System.out.println(",whose level is " + level);
		

		System.out.println(",who works in " + getDept());
		System.out.println(",whose salary is " + salary);
		
		
		System.out.println(",who works for course " + course);		
		System.out.println();
	}
}	



class test
{
	public static void main(String[] args)
	{
		Staff p1 = new Staff("John", "ME", 10000);
		Student p2 = new Student("Mike", "CS", "Senior");
		TA p3 = new TA("Paul", "CT", 6000, "AD", "PhD", "CT5706");

		Person [] p = {p1, p2, p3};
		
		for(int i=0; i<3; i++)
			p[i].print();

		Work [] w = {p1, p3};
		for(int i=0; i<2; i++)
			System.out.println("I work in " + w[i].getDept());

		Study [] s = {p2, p3};
		for(int i=0; i<2; i++)
			System.out.println("I study in " + s[i].getStdDept());
		
		
		/*
		for(int i=0; i<3; i++)
		{
			if(p[i] instanceof Work)
				System.out.println("I work in " + ((Work)p[i]).getDept()); 
		}

		for(int i=0; i<3; i++)
		{
			if(p[i] instanceof Study)
				System.out.println("I study in " + ((Study)p[i]).getStdDept()); 
		}
		*/
	}
}


